"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_dom_1 = require("react-dom");
var mobx_react_1 = require("mobx-react");
exports.inject = mobx_react_1.inject;
exports.observer = mobx_react_1.observer;
var Cans = (function () {
    function Cans() {
        this.__routerComponent = React.createElement('div', null, 'cans');
        this.models = [];
    }
    Cans.prototype.__getInjectList = function () {
        return this.models.map(function (model) { return model.namespace; }).filter(function (_) { return _; });
    };
    Cans.prototype.route = function (routeFunc) {
        // wrap provider
        var providerProps = {};
        this.models.forEach(function (model) {
            providerProps[model.namespace] = model.observable;
        });
        this.__routerComponent = React.createElement(mobx_react_1.Provider, providerProps, routeFunc());
    };
    Cans.prototype.model = function (model) {
        this.models.push(model);
    };
    Cans.prototype.start = function (el) {
        react_dom_1.render(this.__routerComponent, el);
        this.__mountedRoot = el;
    };
    return Cans;
}());
exports.Cans = Cans;
var createCansApp = function () {
    return new Cans();
};
exports.default = createCansApp;
